<template lang="pug">
  .root
    span photo table!
    ul.masonry-container.container(
      v-masonry
      transition-duration=".6s"
      item-selector=".item"
      :data-column="column"
    )
      li.item(
        v-for="(item,index) in photos"
        v-masonry-tile
        v-bind:key="index"
      )
        img(
          @click="onItemClick"
          :data-index="index"
          :src="item.path"
          )
        .meta(v-if="meta")
          p 投稿者: {{item.userName}}
          span
            | 表示 : 
            input(
              type="checkbox"
              :checked="item.active? true : null"
              :name="item.name"
              @input="$emit('toggleActive', $event.target)"
            )
            button(
              @click="$emit('pushPickUp', item.path)"
            ) pikupに追加
            button(
              @click="$emit('unshiftPickup', item.path)"
            ) pikup先頭に追加
</template>
<script>
import Vue from 'vue'

import { VueMasonryPlugin } from 'vue-masonry'
Vue.use(VueMasonryPlugin)

export default {
  name: 'PhotoTabel',
  props: {
    classes: {
      type: Array,
      default: () => []
    },
    photos: {
      type: Array,
      default: () => []
    },
    column: {
      type: String,
      default: () => 'default'
    },
    meta: Boolean,
    openLightBox: Function
  },
  methods: {
    onClick() {
      console.log('click!')
    },
    onItemClick(event) {
      const target = event.target
      // todo: 自分の画像のときわかるように userIdも渡す！
      this.openLightBox({
        href: target.src,
        index: target.dataset.index
      })
    }
  },
  //インスタンスが生成された後に実行
  created() {},
  //インスタンスがマウントされたちょうど後
  mounted: function() {
    this.$redrawVueMasonry()
  }
}
</script>

<style lang="stylus" scoped>
.root
  border: solid 1px $c-green
  font-size: $fz-base
  position: relative
  padding: 0 5px
  .container
    margin: 0 auto
    display: flex
    justify-content: center
    flex-wrap: wrap
    box-sizing: border-box
  .item
    border: 1px solid #ac0
    width: 200px
    box-sizing: border-box
    margin: 5px
    img
      height: auto
      width: 100%
  // column
  .container[data-column="default"]
    > .item
      width: calc(50% - 10px)
      +sp-pad()
        width: calc(25% - 10px)
      +pad-pc()
        width: calc(20% - 10px)
      +pc()
        width: calc(10% - 10px)
  .container[data-column="2"]
    > .item
      width: calc(50% - 10px)
  .container[data-column="3"]
    > .item
      width: calc(33% - 10px)
  // meta info
  .item .meta
    background: $c-border-base
    padding: 4px
    font-size: $fz-ex_small

</style>